
#include "sysreg.h"

#define TLBEHI_INIT					(1 << SYSREG_TLBEHI_V_OFFSET)
#define MMU_VMR_CACHE_WRBACK		((3 << SYSREG_AP_OFFSET) | (3 << SYSREG_SZ_OFFSET) | (1 << SYSREG_TLBELO_D_OFFSET)	\
								|	(1 << SYSREG_B_OFFSET) | (1 << SYSREG_TLBELO_C_OFFSET))
#define MMUCR_SET					((1 << SYSREG_DRP_OFFSET) | (1 << SYSREG_DLA_OFFSET) | (1 << SYSREG_MMUCR_S_OFFSET)	\
								|	(1 << SYSREG_M_OFFSET) | (1 << SYSREG_E_OFFSET))
#define MMUCR_INIT					((1 << SYSREG_MMUCR_S_OFFSET) | (1 << SYSREG_MMUCR_I_OFFSET))
#define TLBELO_INIT					(3 << SYSREG_AP_OFFSET)


			.section	.text._firmwareloader, "ax", @progbits
			.global		_firmwareloader
			.type		_firmwareloader, @function
_firmwareloader:
			pushm	r0-r3, r10
			mov		r0, lo(SpSub)
			orh		r0, hi(SpSub)
			mov		r1, lo(SpSubEnd)
			orh		r1, hi(SpSubEnd)
			rcall	DoInRam
			popm	r0-r3, r10
			retal	r12

			// begin-address of code to move in r0, end-address in r1
DoInRam:	
			mov		r2, lo(0x92000000)			// point to the end of ram
			orh		r2, hi(0x92000000)
			sub		r2, r1						// subtract the size of the program to move
			add		r2, r0
			andl	r2, lo(~0x7)				// make it an 8 byte boundary
			mov		r10, r2						// save the start address
SpmoveLoop:
			ld.w	r3, r0++
			st.w	r2++, r3
			cp.w	r1, r0
			cache	r2[-4], 0x0d				// dcache clean/invalidate
			cache	r2[-4], 0x01				// icache invalidate
			brhi	SpmoveLoop

			sync	0

			icall	r10
			retal	r12


			.balign	4
SpSub:		
			mov		r1, lo(0x10000000)
			orh		r1, hi(0x10000000)
			mov		r0, 102
			st.b	r1++, r0
			mov		r0, 114
			st.b	r1++, r0
			mov		r0, 101
			st.b	r1++, r0
			mov		r0, 101
			st.b	r1++, r0
			mov		r0, sp
			st.w	r1++, r0
			mov		r0, lo(SpSubEnd)
			orh		r0, hi(SpSubEnd)
			st.w	r1++, r0

			/* Flush the caches */
			mov		r1, 0
			cache	r1[4], 8
			cache	r1[0], 0
			sync	0
			retal	r12

			.balign	4
SpSubEnd:

			.section	.text._initprog, "ax", @progbits
			.global _initprog
			.type _initprog, @function
_initprog:
			mov		r1, lo(0xa0000000)
			orh		r1, hi(0xa0000000)
			/* Flush the caches */
			mov		r1, 0
			cache	r1[4], 8
			cache	r1[0], 0
			sync	0
			mov		pc, r1
			
			.section	.text.GetFlashID, "ax", @progbits
			.global		GetFlashID
			.type		GetFlashID, @function
GetFlashID:
			pushm	r0-r7, r10
			mov		r0, lo(irFlashId)
			orh		r0, hi(irFlashId)
			mov		r1, lo(irFlashIdEnd)
			orh		r1, hi(irFlashIdEnd)
			rcall	DoInRam
			popm	r0-r7, r10
			retal	r12

			.balign	4


irFlashId:

			mov		r0, 0
			cache	r0[5], 0x8
			sync	0

			/// Flush the caches
//			mov		r1, 0
//			cache	r1[4], 8
//			cache	r1[0], 0
//			sync	0

			mov		r0, lo(0xA0000AAA)
			orh		r0, hi(0xA0000AAA)
			mov		r2, lo(0xA0001554)
			orh		r2, hi(0xA0001554)
			mov		r1, 0xAA
			mov		r3, 0x55

			st.h	r0[0x0], r1
			st.h	r2[0x0], r3
			mov		r4, 0x90
			st.h	r0[0x0], r4

			mov		r5, lo(0xA0000000)
			orh		r5, hi(0xA0000000)
			ld.w	r12, r5[0x0]

			st.h	r0[0x0], r1
			st.h	r2[0x0], r3
			mov		r1, 0xF0
			st.h	r0[0x0], r1

			/// Flush the caches
			mov		r1, 0
			cache	r1[4], 8
			cache	r1[0], 0
			sync	0

			retal	r12
irFlashIdEnd:



			.section	.text.EraseSector, "ax", @progbits
			.global		EraseSector
			.type		EraseSector, @function
EraseSector:
			pushm	r0-r7, r10
			mov		r0, lo(irEraseSector)
			orh		r0, hi(irEraseSector)
			mov		r1, lo(irEraseSectorEnd)
			orh		r1, hi(irEraseSectorEnd)
			rcall	DoInRam
			popm	r0-r7, r10
			retal	r12


			.balign	4

irEraseSector:
			// flush unlock dcache
			mov		r0, 0
			cache	r0[5], 0x8
			sync	0

			orh		r12, 0xA000
			mov		r0, lo(0xA0000AAA)
			orh		r0, hi(0xA0000AAA)
			mov		r2, lo(0xA0001554)
			orh		r2, hi(0xA0001554)
			mov		r1, 0xAA
			mov		r3, 0x55

			st.h	r0[0x0], r1
			st.h	r2[0x0], r3
			mov		r4, 0x80
			st.h	r0[0x0], r4
			st.h	r0[0x0], r1
			st.h	r2[0x0], r3
			
			mov		r5, 0x30
			st.h	r12[0], r5
eloop:
			ld.uh	r5, r12[0x0]
			mov		r4, 0x80
			and		r4, r5
			brne	finish
			mov		r4, 0x20
			and		r4, r5
			breq	eloop
			ld.uh	r5, r12[0x0]
			mov		r4, 0x80
			and		r4, r5
			brne	finish

			st.h	r0[0x0], r1
			st.h	r2[0x0], r3
			mov		r1, 0xF0
			st.h	r0[0x0], r1
			mov		r12, 1
			rjmp	finish1
			
finish:
			mov		r12, 0
finish1:

			/// Flush the caches
			mov		r1, 0
			cache	r1[4], 8
			cache	r1[0], 0
			sync	0

			retal	r12
irEraseSectorEnd:




			.section	.text.FlashWrite, "ax", @progbits
			.global		FlashWrite
			.type		FlashWrite, @function
FlashWrite:
			pushm	r0-r7, r10
			mov		r0, lo(irProgram)
			orh		r0, hi(irProgram)
			mov		r1, lo(irProgramEnd)
			orh		r1, hi(irProgramEnd)
			rcall	DoInRam
			popm	r0-r7, r10
			retal	r12


			.balign	4

irProgram:
			// flush unlock dcache
			mov		r0, 0
			cache	r0[5], 0x8
			sync	0

			orh		r12, 0xA000					// make the address a P2 sector address

			// load the default addresses and values
			mov		r0, lo(0xA0000AAA)
			orh		r0, hi(0xA0000AAA)
			mov		r2, lo(0xA0001554)
			orh		r2, hi(0xA0001554)
			mov		r1, 0xAA
			mov		r3, 0x55

			// set the configuration register
			st.h	r0[0], r1
			st.h	r2[0], r3
			mov		r4, 0xD0
			st.h	r0[0], r4
			mov		r4, 0x01
			st.h	r0[0], r4					// set the configuration reg. to 1

			mov		r10, r12					// save the address

			// erase the sector
			rcall	_eraseSector
			cp.w	r12, 0
			brne	prfin
			
			// program the word
			st.h	r0[0x0], r1
			st.h	r2[0x0], r3
			mov		r4, 0xA0
			st.h	r0[0x0], r4
			st.h	r10[0], r11					// program the word
			
			// wait until the word is written
prloop:
			ld.uh	r5, r10[0x0]
			mov		r4, r5
			andl	r4, 0x80, COH
			breq	prloop
			mov		r12, 0
			andl	r5, 0x28, COH
			breq	prfin
			mov		r12, 1
prfin:
			// write the product id exit command
			st.h	r0[0x0], r1
			st.h	r2[0x0], r3
			mov		r1, 0xF0
			st.h	r0[0x0], r1

			// Flush the caches
			mov		r1, 0
			cache	r1[4], 8
			cache	r1[0], 0
			sync	0
			retal	r12			
			
			

_eraseSector:
			st.h	r0[0x0], r1
			st.h	r2[0x0], r3
			mov		r4, 0x80
			st.h	r0[0x0], r4
			st.h	r0[0x0], r1
			st.h	r2[0x0], r3
			
			mov		r5, 0x30
			st.h	r12[0], r5
esloop:
			ld.uh	r5, r12[0x0]
			mov		r4, r5
			andl	r4, 0x80, COH
			breq	esloop
			mov		r12, 0
			andl	r5, 0x28, COH
			breq	esfin
			mov		r12, 1
esfin:
			retal	r12
irProgramEnd:




// void WriteFirmware( void )

			.section	.text.WriteFirmware, "ax", @progbits
			.global		WriteFirmware
			.type		WriteFirmware, @function

WriteFirmware:
			pushm	r0-r10
			mov		r0, lo(irfw)
			orh		r0, hi(irfw)
			mov		r1, lo(irfwend)
			orh		r1, hi(irfwend)
			rcall	DoInRam
			popm	r0-r10
			retal	r12


			.balign	4

irfw:
			// flush unlock dcache
			mov		r0, 0
			cache	r0[5], 0x8
			sync	0


			// load the default addresses and values
			mov		r0, lo(0xA0000AAA)
			orh		r0, hi(0xA0000AAA)
			mov		r2, lo(0xA0001554)
			orh		r2, hi(0xA0001554)
			mov		r1, 0xAA
			mov		r3, 0x55
			
			// r6 hold the ram address, where S-records are stored
			mov		r6, lo(0x90000000)
			orh		r6, hi(0x90000000)
			
			// r8 holds the byte count
			mov		r8, 0
			orh		r8, 0
			
			// r9 holds the address of the sector in use
			mov		r9, lo(0x800000)
			orh		r9, hi(0x800000)
			
			// set the configuration register to 1
			st.h	r0[0], r1
			st.h	r2[0], r3
			mov		r4, 0xD0
			st.h	r0[0], r4
			mov		r4, 0x01
			st.h	r0[0], r4					// set the configuration reg. to 1

			bral	gnw0

fwmainloop:
			sub		r8, 2						// count down
			cp.w	r8, 0
			breq	gnw0						// no more words in this line
			sub		r10, -2						// increment the address by two
			bral	gnw2
gnw0:
			// begin to read a new line
			mov		r12, 100					// use it as a count
gnw1:
			sub		r12, 1
			cp.w	r12, 0
			breq	fwerror						// error, no 'S' found

			ld.ub	r11, r6++
			cp.w	r11, 'S'
			brne	gnw1
			
			// 'S' found, now get the type
			ld.ub	r11, r6++
			cp.w	r11, '0'
			breq	gnw0						// ignore the S0-record
			cp.w	r11, '5'
			breq	gnw0						// ignore the S5-record
			cp.w	r11, '7'
			brhs	fwfin						// end found
			cp.w	r11, '2'					// S2 means 3 byte address
			brne	fwerror						// no valid S-record found

			// S2-record found, get the byte-count
			mov		r11, 2

			mov		r5, 0
ghx1:
			ld.ub	r4, r6++
			sub		r4, '0'
			cp.w	r4, 10
			brlo	ghx2
			andl	r4, 0x1F, COH
			sub		r4, 7
ghx2:
			lsl		r5, 4
			or		r5, r4
			sub		r11, 1
			cp.w	r11, 0
			brne	ghx1


			mov		r8, r5
			sub		r8, 4						// adjust the count
			
			// get the address
			mov		r11, 6

			mov		r5, 0
ghx3:
			ld.ub	r4, r6++
			sub		r4, '0'
			cp.w	r4, 10
			brlo	ghx4
			andl	r4, 0x1F, COH
			sub		r4, 7
ghx4:
			lsl		r5, 4
			or		r5, r4
			sub		r11, 1
			cp.w	r11, 0
			brne	ghx3

			mov		r10, r5

			
			// get a word
gnw2:
			mov		r11, 4

			mov		r5, 0
ghx5:
			ld.ub	r4, r6++
			sub		r4, '0'
			cp.w	r4, 10
			brlo	ghx6
			andl	r4, 0x1F, COH
			sub		r4, 7
ghx6:
			lsl		r5, 4
			or		r5, r4
			sub		r11, 1
			cp.w	r11, 0
			brne	ghx5

			mov		r11, r5
			

			mov		r12, r10					// get the address

			// check, if we have to erase the sector
			cp.w	r12, 0x10000				// is it in a 64kb sector?
			brlo	fw1							// it is a 8kb sector
			andh	r12, 0xFFFF, COH			// make the address a sector beginning addr.
			bral	fw2
fw1:
			mov		r4, lo(0xFFFFE000)
			orh		r4, hi(0xFFFFE000)
			and		r12, r4						// make the address a sector beginning addr.
fw2:
			cp.w	r12, r9						// now we compare sectors
			breq	fwp							// the sector should be already erased

			mov		r9, r12						// store the address of the sector to erase

			mov		r12, r10					// get the address
			orh		r12, 0xA000					// make the address a P2 sector address


			// erase the sector
			st.h	r0[0x0], r1
			st.h	r2[0x0], r3
			mov		r4, 0x80
			st.h	r0[0x0], r4
			st.h	r0[0x0], r1
			st.h	r2[0x0], r3
			
			mov		r5, 0x30
			st.h	r12[0], r5
fw3:
			ld.uh	r5, r12[0x0]
			mov		r4, r5
			andl	r4, 0x80, COH
			breq	fw3
			andl	r5, 0x28, COH
			breq	fwp
			mov		r12, 1
			bral	fwfin


fwp:
			mov		r12, r10					// get the address
			orh		r12, 0xA000					// make the address a P2 sector address

			// program the word
			st.h	r0[0x0], r1
			st.h	r2[0x0], r3
			mov		r4, 0xA0
			st.h	r0[0x0], r4
			st.h	r12[0], r11					// program the word
			
			// wait until the word is written
fwloop:
			ld.uh	r5, r12[0x0]
			mov		r4, r5
			andl	r4, 0x80, COH
			breq	fwloop
			andl	r5, 0x28, COH
			breq	fwmainloop
			bral	fwerror

fwfin:
/*
			// flag that we reprogrammed the flash
			mov		r4, lo(0x24007000)
			orh		r4, hi(0x24007000)
			mov		r5, lo(0x55555555)
			orh		r5, hi(0x55555555)
			st.w	r4[0], r5
			mov		r5, lo(0xAAAAAAAA)
			orh		r5, hi(0xAAAAAAAA)
			st.w	r4[4], r5
*/

fwerror:
			// set the configuration register to 0
			st.h	r0[0], r1
			st.h	r2[0], r3
			mov		r4, 0xD0
			st.h	r0[0], r4
			mov		r4, 0
			st.h	r0[0], r4					// set the configuration reg. to 0

			// write the product id exit command
			st.h	r0[0x0], r1
			st.h	r2[0x0], r3
			mov		r4, 0xF0
			st.h	r0[0x0], r4

			// Flush the caches
			mov		r1, 0
			cache	r1[4], 8
			cache	r1[0], 0
			sync	0

			// restart the cpu
			mov		r1, lo(0xa0000000)
			orh		r1, hi(0xa0000000)
			mov		pc, r1
irfwend:


			.section	.text.Test, "ax", @progbits
			.global		Test
			.type		Test, @function
Test:
			pushm	r0-r10
			mov		r8, r11
			mov		r6, r9
			pushm	r12
//			rcall	_getNextWord
			popm	r12
			st.w	r12[0], r8
			st.w	r12[4], r10
			st.w	r12[8], r6
			st.w	r12[12], r11
			
/*			
			mov		r1, r11
			mov		r0, 0
			// check, if we have to erase the sector
			cp.w	r11, 0x10000				// is it in a 64kb sector?
			brlo	t1							// it is a 8kb sector
			andh	r11, 0xFFFF, COH			// make the address a sector beginning addr.
			cp.w	r11, r10						// now we compare sectors
			breq	t3							// the sector is already erased
			bral	t2
t1:
			mov		r4, lo(0xFFFFE000)
			orh		r4, hi(0xFFFFE000)
			and		r11, r4						// make the address a sector beginning addr.
			cp.w	r11, r10						// now we compare sectors
			breq	t3							// the sector is already erased
			
t2:
			mov		r0, 1
t3:
			// store the address of the erased sector
			mov		r9, r1						// get the address back
			andh	r9, 0x1FFF					// make it a physical address
			cp.w	r9, 0x10000
			brlo	t4
			andh	r9, 0xFFFF, COH				// make the address a sector beginning addr.
			bral	t5
t4:
			mov		r4, lo(0xFFFFE000)
			orh		r4, hi(0xFFFFE000)
			and		r9, r4						// make the address a sector beginning addr.
t5:
			st.w	r12[0], r0
			st.w	r12[4], r11
			st.w	r12[8], r9
*/			
			popm	r0-r10
			retal	r12

dv:			.byte	0x12, 0x34, 0x56, 0x78

 			.balign	4
dataValues:
			.word	0x10000000
			.long	0x10000000
			
			
